// TableCell State Constants
var TS_NORMAL = 0;
var TS_HOVER  = 1;
var TS_SELECT = 2;

window.onload = InitTables;
g_utilDoc = parent.parent;

//
// Table Handling Routines
//

// TableCell Constructor
function TableCell (nextScene, styleName)
{
	this.Cell = document.all[styleName + "_" + nextScene];
	this.nextScene = nextScene;
	this.styleName = styleName;
}

function InitTables ()
{

    var indxHTML
    var objCell
    var CellName
    
	for (CellName in TableCells)
	{
		objCell = TableCells[CellName];			
		objCell.name = CellName;
		objCell.HTML = document.all[CellName];
        if (objCell.HTML.length == null)
        {
		    objCell.HTML.onmouseover = OnTableMove;
		    objCell.HTML.onmouseout  = OnTableOut;
			objCell.HTML.onmousedown = OnTableDown;
		    objCell.HTML.style.cursor="hand";						// display a special cursor to say this guy is "hot"
        }
        else
        {
            for (indxHTML = 0; indxHTML < objCell.HTML.length; indxHTML++)
            {
		        objCell.HTML[indxHTML].onmouseover = OnTableMove;
		        objCell.HTML[indxHTML].onmouseout  = OnTableOut;
			    objCell.HTML[indxHTML].onmousedown = OnTableDown;
		        objCell.HTML[indxHTML].style.cursor="hand";						// display a special cursor to say this guy is "hot"
            }
        }
    }
}

function UpdateTables (nextSceneNumber)
{
	for (CellName in TableCells)
	{
		if (TableCells[CellName].nextScene == nextSceneNumber)
            SetCellState (TableCells[CellName], TS_SELECT)
        else
            SetCellState (TableCells[CellName], TS_NORMAL)
    }

}

function OnTableMove ()
{

    var EventCell = event.srcElement
    while (EventCell.tagName != "TD")
        EventCell = EventCell.parentElement

    if (EventCell.className != (TableCells[EventCell.id].styleName + "_selected"))
        SetCellState (TableCells[EventCell.id], TS_HOVER)

}


function OnTableOut ()
{

    var EventCell = event.srcElement
    while (EventCell.tagName != "TD")
        EventCell = EventCell.parentElement

    if (EventCell.className != (TableCells[EventCell.id].styleName + "_selected"))
        SetCellState (TableCells[EventCell.id], TS_NORMAL)

}


function OnTableDown ()
{
    var EventCell = event.srcElement
    while (EventCell.tagName != "TD")
        EventCell = EventCell.parentElement

    var nextScene = TableCells[EventCell.id].nextScene;

	g_utilDoc.ChangeScene(nextScene);
}


function SetCellState (TableCell, state)
{

    var NewClassName

    if (state == TS_NORMAL)
        NewClassName = (TableCell.styleName + "_normal");
    else
    {
        if (state == TS_HOVER)
            NewClassName = (TableCell.styleName + "_hover");
        else
            NewClassName = (TableCell.styleName + "_selected");
    }

    if (TableCell.Cell.length == null)
    {
        TableCell.Cell.className = NewClassName;
        SetSingleCellImage (TableCell.Cell, state, TableCell.styleName)
    }
    else
    {
        for (var indx = 0; indx < TableCell.Cell.length; indx++)
        {
            TableCell.Cell[indx].className = NewClassName;
            SetSingleCellImage (TableCell.Cell[indx], state, TableCell.styleName)
        }
    }
}

function SetSingleCellImage (Cell, state, styleName)
{

    var indxChild  = 0;
    var ImageCount = 0;
    while (Cell.children[indxChild] != null)
    {
        if (Cell.children[indxChild].tagName == "IMG")
        {
            if (ImageCount == state)
				Cell.children[indxChild].className = "";
            else
                Cell.children[indxChild].className = "NavBarBlocked";

            ImageCount++;
        }
        indxChild++;
    }
}

